APTparam <- function(type, ... ) {
	if(type=="cytoscan"){
		APTcytoscan(...)
	} else if(type=="axiom") {
		APTaxiom(...)
	} else {
		stop("Invalid content of 'type'. It must be 'cytoscan' or 'axiom'.")
	}
}

APTcytoscan <- function(cel.list, output.path, ...) {
	new("APTCopyNumberParam",
		cel.list = cel.list,
		output.path = output.path,
		...
	)
}


APTaxiom <- function(cel.list, output.path, ...) {
	params <- list()
	params$qc <- new("APTGenoQcParam",
		cel.list = cel.list,
		output.path = output.path,
		...
	)
	params$genotype <- new("APTProbeSetGenotypeParam",
		cel.list = cel.list,
		output.path = output.path,
		...
	)
	return(params)
}
