
# CY2APT
# -----------------------------------------------------------------------------
# Created: 14/12/2013
# Updated: 11/11/2014

# Cyto2APT <- function(cel.files, output.path, analysis.path, 
#     cdf.file, chrX.probes, chrY.probes, analysis.qca,
#     analysis.qcc, analysis.snp, analysis.annotdb, analysis.refmodel, 
#     verbose = FALSE ) {
# }

Cyto2APT <- function(arguments, verbose=FALSE) {

    # SETUPT
    OptionsAffy.Init("Cyto2APT", verbose)
    # /SETUP

    # SYSTEM
    CheckSystem()
    # /SYSTEM

    ScreenAffy("Creating input file for APT.")
    cel.df <- data.frame(c("cel_files", 
        list.celfiles(arguments@cel.list, full.names=TRUE)))
    
    cel.f <- RandomName(prefix="tmp.cyto.apt.")
    arguments@cel.path <- paste0(cel.f, ".1")
    
    write.table(cel.df, file=arguments@cel.path, quote=FALSE, 
      row.names=FALSE, col.names=FALSE)

    

    ScreenAffy("Creating call to APT.")
    # call <- NULL
    # if(Sys.info()["sysname"] == "Linux") {
    #     call <- CytoCopynumber.Linux(cel.f, output.path, analysis.path,
    #         cdf.file, chrX.probes, chrY.probes, analysis.qca, 
    #         analysis.qcc, analysis.snp, analysis.annotdb, analysis.refmodel)
    # } else {
    #     if(Sys.info()[ "sysname" ] == "Windows") {
    #         call <- CytoCopynumber.Windows(cel.f, output.path, analysis.path,
    #             cdf.file, chrX.probes, chrY.probes, analysis.qca, 
    #             analysis.qcc, analysis.snp, analysis.annotdb, analysis.refmodel)
    #     } else {
    #         call <- CytoCopynumber.Mac(cel.f, output.path, analysis.path,
    #         cdf.file, chrX.probes, chrY.probes, analysis.qca, 
    #         analysis.qcc, analysis.snp, analysis.annotdb, analysis.refmodel)
    #     }
    # }


    # if (!is.null(call)) {
    #     ScreenAffy("Calling APT")
    #     system(call)
    # }

    run(arguments)

    unlink(cel.f, recursive=TRUE, force=TRUE)
}


