\name{Ax2APT}
\alias{Ax2APT}

\title{ 
	Function to run 'apt-geno-qc' and 'apt-probeset-genotype' for Axiom .CEL files given a set of parameters to create the metrix, summary and genotype files need for Ax2Mad and Ax2SnpMatrix.
}

\description{
	This function run as a command line tool the 'apt-geno-qc' and 'apt-probeset-genotype' included into the Affymetrix Port Tools (APT) to process the raw .CEL files and generate the metrix, summary and genotype files need for Ax2Mad and Ax2SnpMatrix
}

\usage{
	Ax2APT(cel.files, output.path, analysis.path, xml.dqc, xml.config.1, xml.config.2, report.txt, verbose)
}

\arguments{
	\item{cel.files}{
		[Mandatory] Location where the raw .CEL files are placed.
	}
	\item{output.path}{
		[Mandatory] Location where the metrix, summary and genotype file will be stored.
	}
	\item{analysis.path}{
		[Mandatory] Path until Axiom library (containing DQC and Step 1 and Step 2 XML files).
	}
	\item{xml.dqc}{
		[Mandatory] XML definition of the QC metric that evaluates the overlap between the two homozygous peaks.
	}
	\item{xml.config.1}{
		[Mandatory] Configuration in XML for the first step of Aciom QC pipeline.
	}
	\item{xml.config.2}{
		[Mandatory] Configuration in XML for the second step of Aciom QC pipeline.
	}
	\item{report.txt}{
		By default 'AxiomGT1.report.txt'. Output name of the QC report generated by APT.
	}
	\item{verbose}{
		By default FALSE. If TRUE the function will shows messages indicating the process.
	}
}

\details{
	~~
}

\note{
	Since the APT are used as a command line tool, the input raw .CEL files cannot contain special characters like '(', ')'...
}

\value{
	If no error is generated during the process, the function will return NA.
}

\examples{
# Ax2APT( 
    # cel.files="raw.data",
    # output.path="ax.apt", 
    # analysis.path="Affymetrix/ChAS/Library/Axiom",
    # xml.dqc="Axiom_GW_Hu_SNP.r6.apt-geno-qc.AxiomQC1.xml", 
    # xml.config.1="Axiom_GW_Hu_SNP_LessThan96_Step1.r6.apt-probeset-genotype.AxiomGT1.xml", 
    # xml.config.2="Axiom_GW_Hu_SNP_LessThan96_Step2.r6.apt-probeset-genotype.AxiomGT1.xml"
# )
}

\keyword{ APT }
\keyword{ APTparam }
\keyword{ Ax2APT }
