\name{Cyto2APT}
\alias{Cyto2APT}

\title{ 
	Function to run 'apt-copynumber-cyto' for CytoScan .CEL files given a set of parameters to create the .cychp.txt files need for Cyto2Mad and Cyto2SnpMatrix.
}

\description{
	This function run as a command line tool the 'apt-copynumber-cyto' included into the Affymetrix Port Tools (APT) to process the raw .CEL files and generate the .cychp.txt files that are requested by Cyto2Mad and Cyto2SnpMatrix.
}

\usage{
	Cyto2APT(arguments, verbose)
}

\arguments{
	\item{arguments}{
		[Mandatory] Object of class 'APTCopyNumberParam' with the 'standard' or 'custom' arguments set.
	}
	\item{verbose}{
		By default FALSE. If TRUE the function will shows messages indicating the process.
	}
}

\details{
	~~
}

\note{
	Since the APT are used as a command line tool, the input raw .CEL files cannot contain special characters like '(', ')'...
}

\value{
	If no error is generated during the process, the function will return NA.
}

\examples{
# aptParam <- APTparam(
	# type="cytoscan", 
	# level="standard",
	# cel.list="C:/Users/brge/Desktop/TEA_1de2", 
	# output.path="C:/Users/brge/Desktop/APT_OUT", 
	# analysis.path="C:/Users/brge/Desktop/lib_cytoHD",
	# cdf="CytoScanHD_Array.cdf", 
	# chrX="CytoScanHD_Array.chrXprobes", 
	# chrY="CytoScanHD_Array.chrYprobes", 
	# qca="CytoScanHD_Array.r1.qca", 
	# qcc="CytoScanHD_Array.r1.qcc", 
	# snp="CytoScanHD_Array.snplist.txt", 
	# annot.db="CytoScanHD_Array.na32.3.annot.db", 
	# refmodel="CytoScanHD_Array.na32.3.v1.REF_MODEL"
# )
# Cyto2APT(aptParam)
}

\keyword{ APT }
\keyword{ APTparam }
\keyword{ Ax2APT }
