\name{CytoQCView}
\alias{CytoQCView}

\title{ 
	Function draw QC charts for CytoScan .cychp.txt files.
}

\description{
	This function allows to draw QC charts for single individual or for population using the .cychp.txt files from CytoScan.
}

\usage{
	Cyto2APT(path, visualization, individual, verbose = FALSE)
}

\arguments{
	\item{path}{
		[Mandatory] Path where the output of the 'Cyto2APT' was stored.
	}
	\item{visualization}{
		[Mandatory] Type of visualization, that can be 'snp', to visualize the genotype of a single snip for all individuals of population, 'int' to display the intensities of all SNPs of a single individual or 'sc' to display the strength vs. contrast of all the SNPs of a single individual.
	}
	\item{individual}{
		If 'visualization' is set to 'snp' it corresponds to a SNP probesetid. If 'visualization' is set to 'int' or to 'sc' it corresponds to the name of an individual.
	}
	\item{verbose}{
		By default FALSE. If TRUE the function will shows messages indicating the process.
	}
}

\details{
	~~
}

\value{
	An object of class 'CytoQCViewer' that can runs over itself the function 'plot'.
}

\examples{
## See the genotype of a single SNP for all individuals in population
# plt <- CytoQCView(apt.output, "snp", individual="C-7RFMM")
# plot(plt)

## See all the intensities from a single individual of the population
# plt <- CytoQCView(apt.output, "int", individual="3B375")
# plot(plt)

## See all the strength vs. contrast from a single individual of the population
# plt <- CytoQCView(apt.output, "sc", individual="3B375")
# plot(plt)
}

\keyword{ APT }
\keyword{ APTparam }
\keyword{ Ax2APT }
